searchNodes=[{"doc":"Main API interface.HTTPStream is a tiny tiny library for streaming big big files. It works by wrapping HTTP requests onto a Stream. You can use it with Flow, write it to disk through regular streams and more!HTTPStream.get(large_image_url) |&gt; Stream.into(File.stream!(&quot;large_image.png&quot;)) |&gt; Stream.run()The adapter can be configured by setting in your config/config.exs:config :http_stream, adapter: HTTPStream.Adapter.MintAt the moment, only two adapters are supported: Mint (default) and HTTPoison.","ref":"HTTPStream.html","title":"HTTPStream","type":"module"},{"doc":"Performs a DELETE request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:query (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#delete/2","title":"HTTPStream.delete/2","type":"function"},{"doc":"Performs a GET request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:query (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#get/2","title":"HTTPStream.get/2","type":"function"},{"doc":"Performs a HEAD request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:query (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#head/2","title":"HTTPStream.head/2","type":"function"},{"doc":"Performs a OPTIONS request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:query (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#options/2","title":"HTTPStream.options/2","type":"function"},{"doc":"Performs a PATCH request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:params (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#patch/2","title":"HTTPStream.patch/2","type":"function"},{"doc":"Performs a POST request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:params (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#post/2","title":"HTTPStream.post/2","type":"function"},{"doc":"Performs a PUT request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:params (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#put/2","title":"HTTPStream.put/2","type":"function"},{"doc":"Performs an HTTP request.Supported methods: GET, OPTIONS, HEAD, TRACE, POST, PUT, PATCH and DELETE","ref":"HTTPStream.html#request/4","title":"HTTPStream.request/4","type":"function"},{"doc":"Performs a TRACE request.Supported options::headers (optional) - Keyword list of HTTP headers to add to the request.:query (optional) - Keyword list of query params to add to the request.","ref":"HTTPStream.html#trace/2","title":"HTTPStream.trace/2","type":"function"},{"doc":"","ref":"HTTPStream.html#t:method/0","title":"HTTPStream.method/0","type":"type"},{"doc":"Adapter behaviour for HTTPStream compatible clients.An adapter must implement the following callbacks:request/1 - Receives an HTTPStream.Request.t() and initiates the HTTP connection to the endpoint.parse_chunks/1 - Receives values of any type returned by request/1 and reads a chunk of data from the connection.close/1 - Called when the final value from parse_chunks/1 is read. Should close the connection.Currently supported adapters: HTTPStream.Adapter.Mint","ref":"HTTPStream.Adapter.html","title":"HTTPStream.Adapter","type":"behaviour"},{"doc":"","ref":"HTTPStream.Adapter.html#c:close/1","title":"HTTPStream.Adapter.close/1","type":"callback"},{"doc":"","ref":"HTTPStream.Adapter.html#c:parse_chunks/1","title":"HTTPStream.Adapter.parse_chunks/1","type":"callback"},{"doc":"","ref":"HTTPStream.Adapter.html#c:request/1","title":"HTTPStream.Adapter.request/1","type":"callback"},{"doc":"Implements HTTPStream.Adapter for the HTTPoison client.HTTPoison performs async requests through messages. This means there is an implicit timeout if, for some reason, the server stops responding. By default this timeout is 30_000 (in milliseconds) but can be configured by setting in your config/config.exs file:config :http_stream, HTTPStream.Adapter.HTTPoison, timeout: 60_000","ref":"HTTPStream.Adapter.HTTPoison.html","title":"HTTPStream.Adapter.HTTPoison","type":"module"},{"doc":"Implements HTTPStream.Adapter for the Mint HTTP Client.","ref":"HTTPStream.Adapter.Mint.html","title":"HTTPStream.Adapter.Mint","type":"module"},{"doc":"Struct that represents a request.Fields:scheme: atom() - e.g. :httphost: binary() - e.g. &quot;localhost&quot;port: integer() - e.g. 80path: binary() - e.g &quot;/users/1/avatar.png&quot;method: String.t() - e.g. &quot;GET&quot;headers: keyword() - e.g. [authorization: &quot;Bearer 123&quot;]body: binary() - e.g. { &quot;id&quot;: &quot;1&quot; }","ref":"HTTPStream.Request.html","title":"HTTPStream.Request","type":"module"},{"doc":"Parses a given URL and uses a given method to generate a valid HTTPStream.Request struct.Supported options:headers - HTTP headers to be sent.body - Body of the HTTP request. This will be the request query field if the method is one of &quot;GET&quot;, &quot;TRACE&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot; and &quot;DELETE&quot;.This function raises an ArgumentError if the HTTP method is unsupported or the url argument isn't a string.","ref":"HTTPStream.Request.html#new/3","title":"HTTPStream.Request.new/3","type":"function"},{"doc":"","ref":"HTTPStream.Request.html#url_for/1","title":"HTTPStream.Request.url_for/1","type":"function"},{"doc":"","ref":"HTTPStream.Request.html#t:t/0","title":"HTTPStream.Request.t/0","type":"type"},{"doc":"HTTPStream!BuildHTTPStream is a tiny, tiny package that wraps HTTP requests into a Stream so that you can manage data on the fly, without keeping everything in memory.Downloading an image:HTTPStream.get(large_image_url) |&gt; Stream.into(File.stream!(&quot;large_image.png&quot;)) |&gt; Stream.run()Streaming multiple images into a ZIP archive (using zstream)[ Zstream.entry(&quot;a.png&quot;, HTTPStream.get(a_url)) Zstream.entry(&quot;b.png&quot;, HTTPStream.get(b_url)) ] |&gt; Zstream.zip() |&gt; Stream.into(File.stream!(&quot;archive.zip&quot;)) |&gt; Stream.run()","ref":"readme.html","title":"HTTPStream","type":"extras"},{"doc":"InstallationDevelopmentContributingAbout","ref":"readme.html#table-of-contents","title":"HTTPStream - Table of Contents","type":"extras"},{"doc":"First, you need to add http_stream to your list of dependencies on mix.exs:def deps do [ {:http_stream, &quot;~&gt; 1.0.0&quot;}, # if using the Mint adapter: {:castore, &quot;~&gt; 0.1.7&quot;}, {:mint, &quot;~&gt; 1.1.0&quot;} # if using the HTTPoison adapter: {:httpoison, &quot;~&gt; 1.7.0&quot;} ] endHTTPStream comes with two adapters: Mint and HTTPoison. By default Mint is configured but you need to include it in your dependencies.To use HTTPoison, set in your config/config.exs:config :http_stream, adapter: HTTPStream.Adapter.HTTPoisonThat's it! For more intricate API details, refer to the documentation.","ref":"readme.html#installation","title":"HTTPStream - Installation","type":"extras"},{"doc":"If you want to setup the project for local development, you can just run the following commands.git clone git@github.com:subvisual/http_stream.git cd http_stream bin/setupPRs and issues welcome.","ref":"readme.html#development","title":"HTTPStream - Development","type":"extras"},{"doc":"Feel free to contribute!If you found a bug, open an issue. You can also open a PR for bugs or new features. Your PRs will be reviewed and subjected to our styleguide and linters.All contributions must follow the Code of Conduct and Subvisual's guides.","ref":"readme.html#contributing","title":"HTTPStream - Contributing","type":"extras"},{"doc":"HTTPStream is maintained with ❤️ by Subvisual.","ref":"readme.html#about","title":"HTTPStream - About","type":"extras"}]